<?php

define('IN_PHPBB', true);
define('BB_SCRIPT', 'online');
define('BB_ROOT', './');
require(BB_ROOT ."common.php");

// Start session management
$user->session_start();
$page_cfg['use_tablesorter'] = true;

//
// Output page header and load viewonline template
//
$template->assign_vars(array(
	'PAGE_TITLE' => $lang['WHOSONLINE'],
));

where_user(array('id' => 0, 'forum_id' => 0, 'type' => 'online'));

//
// Get auth data
//
$is_auth_ary = array();
$is_auth_ary = auth(AUTH_VIEW, AUTH_LIST_ALL, $userdata);

$sql = CACHE('buf_where')->fetch_rowset("SELECT * FROM buf_where ORDER BY time DESC");
foreach($sql as $row)
{
	if(empty($where_row[$row['user_ip']])) $where_row[$row['user_ip']] = $row;
}

//
// Get user list
//
$sql = "SELECT u.user_id, u.username, u.user_opt, u.user_rank, s.session_logged_in, s.session_time, s.session_ip, s.bot_name, s.session_browser
	FROM ".BB_USERS." u, ".BB_SESSIONS." s
	WHERE u.user_id = s.session_user_id
		AND s.session_time >= ".( TIMENOW - 300 ) ."
	ORDER BY u.username ASC, s.session_ip ASC";
if ( !($result = DB()->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Could not obtain regd user/online information', '', __LINE__, __FILE__, $sql);
}

$guest_users = 0;
$registered_users = 0;
$hidden_users = 0;
$bots = 0;

$prev_user = 0;
$prev_ip = '';

$user_id = 0;

while ( $row = DB()->sql_fetchrow($result) )
{
	$view_online = false;

	if ( $row['session_logged_in'] )
	{
		$user_id = $row['user_id'];

		if ( $user_id != $prev_user )
		{
			$username = profile_url($row);

			if ( bf($row['user_opt'], 'user_opt', 'allow_viewonline') )
			{
				$view_online = IS_AM;
				$hidden_users++;

				$username = '<i>' . $username . '</i>';
			}
			else
			{
				$view_online = true;
				$registered_users++;
			}

			$which_counter = 'reg_counter';
			$which_row = 'reg_user_row';
			$prev_user = $user_id;
		}
	}
	else if($row['bot_name'])
	{
		$username = $row['bot_name'];
		$view_online = true;
		$bots++;

		$which_counter = 'bot_counter';
		$which_row = 'bot_user_row';
	}
	else
	{
		if ( $row['session_ip'] != $prev_ip )
		{
			$username = $lang['GUEST'];
			$view_online = true;
			$guest_users++;

			$which_counter = 'guest_counter';
			$which_row = 'guest_user_row';
		}
	}

	if ( $view_online )
	{
		$row_class = !($which_counter % 2) ? 'row1' : 'row2';

        $where_user = isset($where_row[$row['session_ip']]) ? where_user_url($where_row[$row['session_ip']], false) : 'Скрыто или неизвестно';

		$template->assign_block_vars("$which_row", array(
			'ROW_CLASS'  => $row_class,
			'USER'       => $username,
			'LASTUPDATE' => bb_date($row['session_time']),
			'LASTUPDATE_RAW' => $row['session_time'],
			'USERIP'     => decode_ip($row['session_ip']),
			'U_WHOIS_IP' => $bb_cfg['whois_info'] . decode_ip($row['session_ip']),
			'BROWSER'    => $row['session_browser'],
			'WHERE_USER' => (bf($row['user_opt'], 'user_opt', 'allow_viewonline') && !IS_ADMIN) ? 'Скрыто пользователем' : $where_user,
		));

		$which_counter++;
	}
}

if( $registered_users == 0 )
{
	$l_r_user_s = $lang['REG_USERS_ZERO_ONLINE'];
}
else if( $registered_users == 1 )
{
	$l_r_user_s = $lang['REG_USER_ONLINE'];
}
else
{
	$l_r_user_s = $lang['REG_USERS_ONLINE'];
}

if( $hidden_users == 0 )
{
	$l_h_user_s = $lang['HIDDEN_USERS_ZERO_ONLINE'];
}
else if( $hidden_users == 1 )
{
	$l_h_user_s = $lang['HIDDEN_USER_ONLINE'];
}
else
{
	$l_h_user_s = $lang['HIDDEN_USERS_ONLINE'];
}

if( $guest_users == 0 )
{
	$l_g_user_s = $lang['GUEST_USERS_ZERO_ONLINE'];
}
else if( $guest_users == 1 )
{
	$l_g_user_s = $lang['GUEST_USER_ONLINE'];
}
else
{
	$l_g_user_s = $lang['GUEST_USERS_ONLINE'];
}

$template->assign_vars(array(
	'TOTAL_USERS_ONLINE' => $l_r_user_s + $registered_users + $l_h_user_s + $hidden_users + $l_g_user_s + $guest_users + $bots,
	'TOTAL_REGISTERED_USERS_ONLINE' => sprintf($l_r_user_s, $registered_users) . sprintf($l_h_user_s, $hidden_users),
	'TOTAL_GUEST_USERS_ONLINE' => sprintf($l_g_user_s, $guest_users),
	'TOTAL_BOTS_ONLINE' => $bots,
));

if ( $registered_users + $hidden_users == 0 )
{
	$template->assign_vars(array(
		'L_NO_REGISTERED_USERS_BROWSING' => $lang['NO_USERS_BROWSING'])
	);
}

if ( $guest_users == 0 )
{
	$template->assign_vars(array(
		'L_NO_GUESTS_BROWSING' => $lang['NO_USERS_BROWSING'])
	);
}

print_page('viewonline.tpl');
